# print.tcl --
#
# Handles printing of a message
#
#
#  TkRat software and its included text is Copyright 1996 by Martin Forssen.
#
#  The full text of our legal notices is contained in the file called
#  COPYRIGHT, included with this distribution.


# This is used to generate unique print handles
set printIdentifier 0

# Print --
#
# Prints the given message. This is done very simply, we just ask the
# textwidget in the folder window for its content and send it to the
# print command.
#
# Arguments:
# handler -	Handler of the corresponding folder command

proc Print {handler} {
    global option printIdentifier
    upvar #0 $handler fh

    # Create identifier
    set id print[incr printIdentifier]
    upvar #0 $id pr

    set pr(fileName) $option(tmp)/rat.[RatGenId]
    set tmpFH [open $pr(fileName) w]
    puts $tmpFH [$fh(text) get 0.0 end]
    close $tmpFH

    if { 0 == [regsub "%s" $option(print_command) $pr(fileName) cmd]} {
	set cmd "$option(print_command) $pr(fileName)"
    }
    RatBgExec ${id}(exitStatus) $cmd
    trace variable pr(exitStatus) w PrintDone
}

# PrintDone --
#
# Is called by the trace callback when the print command is done. It is
# meant to do any cleaning up.
#
# Arguments:
# name1, name2 -	Variable specifiers
# op	       -	Operation

proc PrintDone {name1 name2 op} {
    upvar #0 $name1 pr

    exec rm -f $pr(fileName) &
    unset pr
}
